SystemOrganization addCategory: #TpObjetos!

Object subclass: #Alumno
	instanceVariableNames: 'atencion motivacion animo estado temasAprendidos temasImprescindibles calificacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

Alumno class
	instanceVariableNames: 'atencion motivacion animo estado temasAprendidos calificacion'!

Alumno class
	instanceVariableNames: 'atencion motivacion animo estado temasAprendidos calificacion'!

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 19:58'!
animar
(estado = nil) ifTrue: [self estado: 1].
self animo: (Estados dameEstado: (estado+1)).
self estado: (estado+1).! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 02:53'!
animo
^animo.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 9/20/2012 03:18'!
animo: unEstado
animo := unEstado.! !

!Alumno methodsFor: 'Do' stamp: 'LeoComparin 9/25/2012 01:08'!
aprender: unTema
(temasAprendidos isNil) ifTrue: [	temasAprendidos := Set new.
									temasImprescindibles := Set new].
(unTema complejo)
	 ifTrue: [((atencion >= (0.9*(unTema interes)) & (motivacion)))
			ifTrue: [temasAprendidos add: unTema.
					self atencion: (atencion + ((unTema interes)/2) ).
					self motivar.
					self animar]]
		
	ifFalse: [((unTema estado = animo) & (atencion > 50))
			ifTrue: [temasAprendidos add: unTema.
					self atencion: (atencion + 10).
					self motivar.
					self animar]].! !

!Alumno methodsFor: 'Do' stamp: 'LeoComparin 9/25/2012 01:09'!
aprenderImprescindible: unTema
(temasAprendidos isNil) ifTrue: [temasAprendidos := Set new].
(temasImprescindibles isNil) ifTrue: [temasImprescindibles := Set new].
(unTema complejo)
	 ifTrue: [((atencion >= (0.9*(unTema interes)) & (motivacion)))
			ifTrue: [temasAprendidos add: unTema.
					temasImprescindibles add: unTema.
					self atencion: (atencion + ((unTema interes)/2) ).
					self motivar.
					self animar]]
		
	ifFalse: [((unTema estado = animo) & (atencion > 50))
			ifTrue: [temasAprendidos add: unTema.
					temasImprescindibles add: unTema.
					self atencion: (atencion + 10).
					self motivar.
					self animar]].! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 02:53'!
atencion
^atencion.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 9/24/2012 21:20'!
atencion: unNumero
(unNumero >100) ifTrue: [atencion := 100]
ifFalse: [atencion := unNumero].! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:00'!
calificacion
^calificacion.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 19:17'!
calificacion: unNumero
(unNumero >= 4) 	ifTrue: [calificacion := unNumero]
					ifFalse: [calificacion := 2].! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 19:58'!
desanimar
(estado = nil) ifTrue: [self estado: 1].
self animo: (Estados dameEstado: (estado-1)).
self estado: (estado-1).! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 04:53'!
desmotivar
motivacion := false.! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 10/4/2012 19:31'!
estado
^estado.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 19:46'!
estado: unNumero
(unNumero > (Estados max))
ifTrue: [estado := (Estados max)]
ifFalse: [(unNumero <1) 
	ifTrue: [estado := 1] 
	ifFalse: [estado := unNumero]].! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 17:34'!
invertirMotivacion
motivacion :=  motivacion not.! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 02:53'!
motivacion
^motivacion.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 04:53'!
motivar
motivacion := true.! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'LeoComparin 9/23/2012 03:44'!
new
^super new initialize! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 06:34'!
temas
^temasAprendidos.! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 19:11'!
temasAprendidos
^temasAprendidos.! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 20:02'!
temasImprescindibles
^temasImprescindibles.! !

Object subclass: #Clase
	instanceVariableNames: 'curso'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Clase class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/4/2012 18:57'!
para: unCurso
|unaClase|

unaClase := self new.
unaClase curso: unCurso.
^unaClase.! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/4/2012 18:25'!
analogia
curso alumnos do: [:unAlumno | 
	((unAlumno atencion) > 30) 
		ifTrue:
		[unAlumno atencion: ((unAlumno atencion) +10).
		unAlumno motivar]
		
		ifFalse: [unAlumno desanimar]].! !

!Clase methodsFor: 'Getters' stamp: 'LeoComparin 10/4/2012 19:07'!
curso
^curso.! !

!Clase methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 18:54'!
curso: unCurso
curso := unCurso.! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:41'!
diapositivas
"Explicar un tema mediante diapositivas. Aumenta la atencion de todo el curso un 20%, pero si el alumno se quiere ir o esta mas o menos se desmotiva"

curso alumnos do: [:unAlumno | 
	((unAlumno animo = (Estados mostrarEstados at: 1)) | (unAlumno animo = (Estados mostrarEstados at: 2))) 	ifTrue: [unAlumno desmotivar].
	unAlumno atencion: ((unAlumno atencion)*1.2)].! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:36'!
ejercitar
"Dar ejercicios para resolver en clase. Si el alumno esta motivado mejora su estado de animo y su nivel de atencion sube a 80 a menos que sea mayor, en ese caso queda igual. 
En caso contrario, si el alumno esta desmotivado, automaticamente quiere irse y su nivel de atencion baja a un 30% de este"

curso alumnos do: [:unAlumno | 
	(unAlumno motivacion) 
	ifTrue: [unAlumno animar.
	(unAlumno atencion <80) ifTrue: [Estados atencion: 80]]

	ifFalse: [unAlumno animo: (Estados mostrarEstados at: 1).
	unAlumno atencion: (unAlumno atencion)*0.3]].! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/4/2012 18:38'!
explicar: unTema
curso teDoy: unTema.! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/4/2012 18:38'!
explicarImprescindible: unTema
curso teDoyImp: unTema.! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:43'!
payasada
curso alumnos do: [:unAlumno |
	unAlumno atencion: ((unAlumno atencion) *2).
	unAlumno invertirMotivacion.
	((unAlumno animo) = (Estados mostrarEstados at:4)) ifTrue: [unAlumno animo: (Estados mostrarEstados at:1)]
	ifFalse: [unAlumno animar]].
! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:46'!
receso: unTiempo
curso alumnos do: [:unAlumno | 
			unAlumno atencion:  ((unAlumno atencion) + unTiempo).
			(((unAlumno animo) = (Estados mostrarEstados at:1) | (unAlumno animo) = (Estados mostrarEstados at:2)) & ((unAlumno atencion) < 50)) 
			ifTrue: [unAlumno atencion: ((unAlumno atencion) *2)]
			ifFalse: [unAlumno animar]].! !

Object subclass: #Curso
	instanceVariableNames: 'alumnos docente temasVistos temasImprescindibles esponjas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Curso class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/4/2012 18:12'!
nuevo
| unCurso |

unCurso  := self new.
unCurso comenzarCurso.
^unCurso.! !

!Curso methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 19:09'!
alumnos
^alumnos.! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/4/2012 18:23'!
aprobados
| aprobados |

aprobados := (alumnos select: [:alum | alum calificacion >=4])size.
(alumnos size >0) ifTrue: [^aprobados/(alumnos size)*100].! !

!Curso methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 18:15'!
comenzarCurso
alumnos := Set new.
temasVistos := Bag new.
temasVistosMasDeDosVeces := Set new.
temasImprescindibles := Set new.! !

!Curso methodsFor: 'Getters' stamp: 'LeoComparin 10/4/2012 19:05'!
docente
^docente.! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/4/2012 18:19'!
evaluacion
	| materias totales |

totales := (docente temasTotales size).
alumnos do: [:unAlumno | materias := (unAlumno temasAprendidos size).
			((unAlumno temasImprescindibles size ) = (temasImprescindibles size)) ifTrue: 
			[unAlumno calificacion: (( materias / totales ) * 10)]
	
			ifFalse: [unAlumno calificacion: 2]].! !

!Curso methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 18:15'!
inscribir: unAlumno
alumnos add: unAlumno.! !

!Curso methodsFor: 'Getters' stamp: 'LeoComparin 10/4/2012 18:11'!
repetidos
^temasVistosMasDeDosVeces  size.! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:32'!
teDoy: unTema
alumnos do: [:unAlumno| unAlumno aprender: unTema].
docente agregarTema: unTema.
temasVistos add: unTema.! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:32'!
teDoyImp: unTema
alumnos do: [:unAlumno| unAlumno aprenderImprescindible: unTema].
docente agregarTema: unTema.
temasVistos add: unTema.
temasImprescindibles add: unTema.
! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/4/2012 18:20'!
temaMenosAprendido
| ordenados |

ordenados := docente temasTotales asSortedCollection: [:a :b | (alumnos inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: a)]) <  (alumnos inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: b)])].

(ordenados size >=1)
ifTrue: [ ^ ordenados first nombre] .! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:30'!
temaMenosAprendidoVarias
| ordenados varios|

varios := temasVistos select: [:unTema | (temasVistos occurrencesOf: unTema ) >1].

ordenados := varios asSortedCollection: [:a :b | (alumnos inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: a)]) <  (alumnos inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: b)])].

(ordenados size >=1)
ifTrue: [ ^ ordenados first nombre] .! !

!Curso methodsFor: 'Getters' stamp: 'LeoComparin 10/4/2012 18:11'!
temasVistos
^temasVistos.! !

!Curso methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 19:05'!
tuDocenteEs: unDocente
docente := unDocente.! !

Object subclass: #Docente
	instanceVariableNames: 'temasTotales'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Docente class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 9/25/2012 00:26'!
nuevo
| unDocente |

unDocente := self new.
unDocente comenzarCurso.
^unDocente.! !

!Docente methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 18:44'!
agregarTema: unTema
temasTotales add: unTema.! !

!Docente methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 18:49'!
comenzarCurso
temasTotales := Set new.! !

!Docente methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 19:15'!
temasTotales
^temasTotales.! !

Object subclass: #Estados
	instanceVariableNames: ''
	classVariableNames: 'Estados Max'
	poolDictionaries: ''
	category: 'TpObjetos'!

!Estados class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/4/2012 19:47'!
dameEstado: unNumero
(unNumero > Max)
ifTrue: [^Estados at: Max]
ifFalse: [(unNumero <1) 
	ifTrue: [^Estados at: 1] 
	ifFalse: [^Estados at: unNumero]].! !

!Estados class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/4/2012 19:36'!
iniciarEstados
Estados := OrderedCollection new.
Estados add: 'me quiero ir'.
Estados add: 'mas o menos'.
Estados add: 'todo bien'.
Estados add: 'con ganas de ser ayudante'.
Max := 4.! !

!Estados class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/4/2012 19:43'!
max
^Max.! !

!Estados class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/4/2012 19:33'!
mostrarEstados
^Estados.! !

Object subclass: #Tema
	instanceVariableNames: 'nombre complejo interes estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Tema class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/1/2012 00:05'!
new: unNombre
|tema|

tema := Tema new.
tema nombre: unNombre.
^tema.! !

!Tema methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 06:23'!
complejo
^complejo.! !

!Tema methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 06:23'!
esComplejo
complejo := true.! !

!Tema methodsFor: 'Setters' stamp: 'LeoComparin 9/25/2012 01:21'!
esSimple
complejo := false.! !

!Tema methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:22'!
estado
^estado.! !

!Tema methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 03:20'!
estado: algo
estado := algo.! !

!Tema methodsFor: 'Setters' stamp: 'LeoComparin 10/5/2012 01:09'!
estadoNum: unNumero
| algo |

(unNumero > (Estados max))
ifTrue: [algo := (Estados mostrarEstados at:  (Estados max))]
ifFalse: [(unNumero <1) 
	ifTrue: [algo := (Estados mostrarEstados at: 1)] 
	ifFalse: [algo := (Estados mostrarEstados at: unNumero)]].

estado := algo.! !

!Tema methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:22'!
interes
^interes.! !

!Tema methodsFor: 'Setters' stamp: 'LeoComparin 9/27/2012 05:12'!
interes: unNumero
(unNumero >100) ifTrue: [interes := 100]
ifFalse: [interes := unNumero].! !

!Tema methodsFor: 'Getters' stamp: 'LeoComparin 9/25/2012 02:26'!
nombre
^nombre.! !

!Tema methodsFor: 'Setters' stamp: 'LeoComparin 9/25/2012 02:26'!
nombre: unNombre
nombre := unNombre .! !
